diff --git a/src/backend/access/gist/gist.c b/src/backend/access/gist/gist.c
index 79030e7715..d94d9d33a6 100644
--- a/src/backend/access/gist/gist.c
+++ b/src/backend/access/gist/gist.c
@@ -242,6 +242,9 @@ gistplacetopage(Relation rel, Size freespace, GISTSTATE *giststate,
 	if (GistFollowRight(page))
 		elog(ERROR, "concurrent GiST page split was incomplete");
 
+	/* should never try to insert to a deleted page */
+	Assert(!GistPageIsDeleted(page));
+
 	*splitinfo = NIL;
 
 	/*
@@ -857,7 +860,7 @@ gistdoinsert(Relation r, IndexTuple itup, Size freespace,
 					 */
 				}
 				else if ((GistFollowRight(stack->page) ||
-						  stack->parent->lsn < GistPageGetNSN(stack->page)) &&
+						  stack->parent->lsn < GistPageGetNSN(stack->page)) ||
 						 GistPageIsDeleted(stack->page))
 				{
 					/*
